## GtkTreeStore GtkTreeStore — A tree-like data structure that can be used with the GtkTreeView |

## Functions

GtkTreeStore * | gtk_tree_store_new ()
GtkTreeStore * | gtk_tree_store_newv ()
void | gtk_tree_store_set_column_types ()
void | gtk_tree_store_set_value ()
void | gtk_tree_store_set ()
void | gtk_tree_store_set_valist ()
void | gtk_tree_store_set_valuesv ()
gboolean | gtk_tree_store_remove ()
void | gtk_tree_store_insert ()
void | gtk_tree_store_insert_before ()
void | gtk_tree_store_insert_after ()
void | gtk_tree_store_insert_with_values ()
void | gtk_tree_store_insert_with_valuesv ()
void | gtk_tree_store_prepend ()
void | gtk_tree_store_append ()
gboolean | gtk_tree_store_is_ancestor ()
gint | gtk_tree_store_iter_depth ()
void | gtk_tree_store_clear ()
gboolean | gtk_tree_store_iter_is_valid ()
void | gtk_tree_store_reorder ()
void | gtk_tree_store_swap ()
void | gtk_tree_store_move_before ()
void | gtk_tree_store_move_after ()

## Types and Values

struct | GtkTreeStore

## Object Hierarchy

        GObject
        ╰── GtkTreeStore

## Implemented Interfaces

GtkTreeStore implements GtkTreeModel, GtkTreeDragSource, GtkTreeDragDest, GtkTreeSortable and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkTreeStore object is a list model for use with a GtkTreeView widget. It implements the GtkTreeModel interface, and consequentially, can use all of the methods available there. It also implements the GtkTreeSortable interface so it can be sorted by the view. Finally, it also implements the tree drag and drop interfaces.

### GtkTreeStore as GtkBuildable

The GtkTreeStore implementation of the GtkBuildable interface allows to specify the model columns with a `<columns>` element that may contain multiple `<column>` elements, each specifying one model column. The “type” attribute specifies the data type for the column.

An example of a UI Definition fragment for a tree store:

    1
    2
    3
    4
    5
    6
    7
    <object class="GtkTreeStore">
      <columns>
        <column type="gchararray"/>
        <column type="gchararray"/>
        <column type="gint"/>
      </columns>
    </object>

## Functions

### gtk_tree_store_new ()

    GtkTreeStore *
    gtk_tree_store_new (gint n_columns,
                        ...);

Creates a new tree store as with `n_columns` columns each of the types passed in. Note that only types derived from standard GObject fundamental types are supported.

As an example, `gtk_tree_store_new (3, G_TYPE_INT, G_TYPE_STRING, GDK_TYPE_PIXBUF);` will create a new GtkTreeStore with three columns, of type gint, gchararray, and GdkPixbuf respectively.

#### Parameters

n_columns | number of columns in the tree store |
... | all GType types for the columns, from first to last |

#### Returns

a new GtkTreeStore

### gtk_tree_store_newv ()

    GtkTreeStore *
    gtk_tree_store_newv (gint n_columns,
                         GType *types);

Non vararg creation function. Used primarily by language bindings.

[rename-to gtk_tree_store_new]

#### Parameters

n_columns | number of columns in the tree store |
types | an array of GType types for the columns, from first to last. | [array length=n_columns]

#### Returns

a new GtkTreeStore.

[transfer full]

### gtk_tree_store_set_column_types ()

    void
    gtk_tree_store_set_column_types (GtkTreeStore *tree_store,
                                     gint n_columns,
                                     GType *types);

This function is meant primarily for GObjects that inherit from GtkTreeStore, and should only be used when constructing a new GtkTreeStore. It will not function after a row has been added, or a method on the GtkTreeModel interface is called.

#### Parameters

tree_store | A GtkTreeStore |
n_columns | Number of columns for the tree store |
types | An array of GType types, one for each column. | [array length=n_columns]

### gtk_tree_store_set_value ()

    void
    gtk_tree_store_set_value (GtkTreeStore *tree_store,
                              GtkTreeIter *iter,
                              gint column,
                              GValue *value);

Sets the data in the cell specified by `iter` and `column` . The type of `value` must be convertible to the type of the column.

#### Parameters

tree_store | a GtkTreeStore |
iter | A valid GtkTreeIter for the row being modified |
column | column number to modify |
value | new value for the cell |

### gtk_tree_store_set ()

    void
    gtk_tree_store_set (GtkTreeStore *tree_store,
                        GtkTreeIter *iter,
                        ...);

Sets the value of one or more cells in the row referenced by `iter` . The variable argument list should contain integer column numbers, each column number followed by the value to be set. The list is terminated by a -1. For example, to set column 0 with type `G_TYPE_STRING` to “Foo”, you would write `gtk_tree_store_set (store, iter, 0, "Foo", -1)`.

The value will be referenced by the store if it is a `G_TYPE_OBJECT`, and it will be copied if it is a `G_TYPE_STRING` or `G_TYPE_BOXED`.

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter for the row being modified |
... | pairs of column number and value, terminated with -1 |

### gtk_tree_store_set_valist ()

    void
    gtk_tree_store_set_valist (GtkTreeStore *tree_store,
                               GtkTreeIter *iter,
                               va_list var_args);

See `gtk_tree_store_set()`; this version takes a va_list for use by language bindings.

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter for the row being modified |
var_args | va_list of column/value pairs |

### gtk_tree_store_set_valuesv ()

    void
    gtk_tree_store_set_valuesv (GtkTreeStore *tree_store,
                                GtkTreeIter *iter,
                                gint *columns,
                                GValue *values,
                                gint n_values);

A variant of `gtk_tree_store_set_valist()` which takes the columns and values as two arrays, instead of varargs. This function is mainly intended for language bindings or in case the number of columns to change is not known until run-time.

[rename-to gtk_tree_store_set]

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter for the row being modified |
columns | an array of column numbers. | [array length=n_values]
values | an array of GValues. | [array length=n_values]
n_values | the length of the `columns` and `values` arrays |

Since: 2.12

### gtk_tree_store_remove ()

    gboolean
    gtk_tree_store_remove (GtkTreeStore *tree_store,
                           GtkTreeIter *iter);

Removes `iter` from `tree_store` . After being removed, `iter` is set to the next valid row at that level, or invalidated if it previously pointed to the last one.

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter |

#### Returns

`TRUE` if `iter` is still valid, `FALSE` if not.

### gtk_tree_store_insert ()

    void
    gtk_tree_store_insert (GtkTreeStore *tree_store,
                           GtkTreeIter *iter,
                           GtkTreeIter *parent,
                           gint position);

Creates a new row at `position` . If parent is non-`NULL`, then the row will be made a child of `parent` . Otherwise, the row will be created at the toplevel. If `position` is -1 or is larger than the number of rows at that level, then the new row will be inserted to the end of the list. `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_tree_store_set()` or `gtk_tree_store_set_value()`.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]
position | position to insert the new row, or -1 for last |

### gtk_tree_store_insert_before ()

    void
    gtk_tree_store_insert_before (GtkTreeStore *tree_store,
                                  GtkTreeIter *iter,
                                  GtkTreeIter *parent,
                                  GtkTreeIter *sibling);

Inserts a new row before `sibling` . If `sibling` is `NULL`, then the row will be appended to `parent` ’s children. If `parent` and `sibling` are `NULL`, then the row will be appended to the toplevel. If both `sibling` and `parent` are set, then `parent` must be the parent of `sibling` . When `sibling` is set, `parent` is optional.

`iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_tree_store_set()` or `gtk_tree_store_set_value()`.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]
sibling | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_tree_store_insert_after ()

    void
    gtk_tree_store_insert_after (GtkTreeStore *tree_store,
                                 GtkTreeIter *iter,
                                 GtkTreeIter *parent,
                                 GtkTreeIter *sibling);

Inserts a new row after `sibling` . If `sibling` is `NULL`, then the row will be prepended to `parent` ’s children. If `parent` and `sibling` are `NULL`, then the row will be prepended to the toplevel. If both `sibling` and `parent` are set, then `parent` must be the parent of `sibling` . When `sibling` is set, `parent` is optional.

`iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_tree_store_set()` or `gtk_tree_store_set_value()`.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]
sibling | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_tree_store_insert_with_values ()

    void
    gtk_tree_store_insert_with_values (GtkTreeStore *tree_store,
                                       GtkTreeIter *iter,
                                       GtkTreeIter *parent,
                                       gint position,
                                       ...);

Creates a new row at `position` . `iter` will be changed to point to this new row. If `position` is -1, or larger than the number of rows on the list, then the new row will be appended to the list. The row will be filled with the values given to this function.

Calling `gtk_tree_store_insert_with_values (tree_store, iter, position, ...)` has the same effect as calling

    1
    2
    gtk_tree_store_insert (tree_store, iter, position);
    gtk_tree_store_set (tree_store, iter, ...);

with the different that the former will only emit a row_inserted signal, while the latter will emit row_inserted, row_changed and if the tree store is sorted, rows_reordered. Since emitting the rows_reordered signal repeatedly can affect the performance of the program, `gtk_tree_store_insert_with_values()` should generally be preferred when inserting rows in a sorted tree store.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set the new row, or `NULL`. | [out][allow-none]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]
position | position to insert the new row, or -1 to append after existing rows |
... | pairs of column number and value, terminated with -1 |

Since: 2.10

### gtk_tree_store_insert_with_valuesv ()

    void
    gtk_tree_store_insert_with_valuesv (GtkTreeStore *tree_store,
                                        GtkTreeIter *iter,
                                        GtkTreeIter *parent,
                                        gint position,
                                        gint *columns,
                                        GValue *values,
                                        gint n_values);

A variant of `gtk_tree_store_insert_with_values()` which takes the columns and values as two arrays, instead of varargs. This function is mainly intended for language bindings.

[rename-to gtk_tree_store_insert_with_values]

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set the new row, or `NULL`. | [out][allow-none]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]
position | position to insert the new row, or -1 for last |
columns | an array of column numbers. | [array length=n_values]
values | an array of GValues. | [array length=n_values]
n_values | the length of the `columns` and `values` arrays |

Since: 2.10

### gtk_tree_store_prepend ()

    void
    gtk_tree_store_prepend (GtkTreeStore *tree_store,
                            GtkTreeIter *iter,
                            GtkTreeIter *parent);

Prepends a new row to `tree_store` . If `parent` is non-`NULL`, then it will prepend the new row before the first child of `parent` , otherwise it will prepend a row to the top level. `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_tree_store_set()` or `gtk_tree_store_set_value()`.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set to the prepended row. | [out]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_tree_store_append ()

    void
    gtk_tree_store_append (GtkTreeStore *tree_store,
                           GtkTreeIter *iter,
                           GtkTreeIter *parent);

Appends a new row to `tree_store` . If `parent` is non-`NULL`, then it will append the new row after the last child of `parent` , otherwise it will append a row to the top level. `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_tree_store_set()` or `gtk_tree_store_set_value()`.

#### Parameters

tree_store | A GtkTreeStore |
iter | An unset GtkTreeIter to set to the appended row. | [out]
parent | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_tree_store_is_ancestor ()

    gboolean
    gtk_tree_store_is_ancestor (GtkTreeStore *tree_store,
                                GtkTreeIter *iter,
                                GtkTreeIter *descendant);

Returns `TRUE` if `iter` is an ancestor of `descendant` . That is, `iter` is the parent (or grandparent or great-grandparent) of `descendant` .

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter |
descendant | A valid GtkTreeIter |

#### Returns

`TRUE`, if `iter` is an ancestor of `descendant`

### gtk_tree_store_iter_depth ()

    gint
    gtk_tree_store_iter_depth (GtkTreeStore *tree_store,
                               GtkTreeIter *iter);

Returns the depth of `iter` . This will be 0 for anything on the root level, 1 for anything down a level, etc.

#### Parameters

tree_store | A GtkTreeStore |
iter | A valid GtkTreeIter |

#### Returns

The depth of `iter`

### gtk_tree_store_clear ()

    void
    gtk_tree_store_clear (GtkTreeStore *tree_store);

Removes all rows from `tree_store`

#### Parameters

tree_store | a GtkTreeStore |

### gtk_tree_store_iter_is_valid ()

    gboolean
    gtk_tree_store_iter_is_valid (GtkTreeStore *tree_store,
                                  GtkTreeIter *iter);

WARNING: This function is slow. Only use it for debugging and/or testing purposes.

Checks if the given iter is a valid iter for this GtkTreeStore.

#### Parameters

tree_store | A GtkTreeStore. |
iter | A GtkTreeIter. |

#### Returns

`TRUE` if the iter is valid, `FALSE` if the iter is invalid.

Since: 2.2

### gtk_tree_store_reorder ()

    void
    gtk_tree_store_reorder (GtkTreeStore *tree_store,
                            GtkTreeIter *parent,
                            gint *new_order);

Reorders the children of `parent` in `tree_store` to follow the order indicated by `new_order` . Note that this function only works with unsorted stores.

[skip]

#### Parameters

tree_store | A GtkTreeStore |
parent | A GtkTreeIter, or `NULL`. | [nullable]
new_order | an array of integers mapping the new position of each child to its old position before the re-ordering, i.e. `new_order` `[newpos] = oldpos`. | [array]

Since: 2.2

### gtk_tree_store_swap ()

    void
    gtk_tree_store_swap (GtkTreeStore *tree_store,
                         GtkTreeIter *a,
                         GtkTreeIter *b);

Swaps `a` and `b` in the same level of `tree_store` . Note that this function only works with unsorted stores.

#### Parameters

tree_store | A GtkTreeStore. |
a | A GtkTreeIter. |
b | Another GtkTreeIter. |

Since: 2.2

### gtk_tree_store_move_before ()

    void
    gtk_tree_store_move_before (GtkTreeStore *tree_store,
                                GtkTreeIter *iter,
                                GtkTreeIter *position);

Moves `iter` in `tree_store` to the position before `position` . `iter` and `position` should be in the same level. Note that this function only works with unsorted stores. If `position` is `NULL`, `iter` will be moved to the end of the level.

#### Parameters

tree_store | A GtkTreeStore. |
iter | A GtkTreeIter. |
position | A GtkTreeIter or `NULL`. | [allow-none]

Since: 2.2

### gtk_tree_store_move_after ()

    void
    gtk_tree_store_move_after (GtkTreeStore *tree_store,
                               GtkTreeIter *iter,
                               GtkTreeIter *position);

Moves `iter` in `tree_store` to the position after `position` . `iter` and `position` should be in the same level. Note that this function only works with unsorted stores. If `position` is `NULL`, `iter` will be moved to the start of the level.

#### Parameters

tree_store | A GtkTreeStore. |
iter | A GtkTreeIter. |
position | A GtkTreeIter. | [allow-none]

Since: 2.2

## Types and Values

### struct GtkTreeStore

    struct GtkTreeStore;

## See Also

GtkTreeModel